<template>
  <div class="list_container">
    <apass-list
      ref="list"
      :list-header="listHeader"
      :list-data="listData"
      :list-total="listTotal"
      :hide-search="true"
      :list-padding-left="0"
      @list-action="initList"
    >
      <el-breadcrumb separator="/" slot="breadcrumb">
        <el-breadcrumb-item :to="{ path: '/message' }">
          {{ $t("lang.message") }}
        </el-breadcrumb-item>
        <el-breadcrumb-item>
          {{ $t("lang.banner") }}
        </el-breadcrumb-item>
      </el-breadcrumb>

      <template slot="top">
        <div class="top_fliter">
          <show-more-filter class="filter_list">
            <div class="filter_item">
              <span class="filter_title">banner搜索：</span>
              <el-input
                v-model="topFilter.name"
                placeholder="请输入banner关键词"
              ></el-input>
            </div>
            <div class="filter_item">
              <span class="filter_title">状态：</span>
              <el-select v-model="topFilter.state" placeholder="请选择">
                <el-option label="全部" value=""> </el-option>
                <el-option label="已上架" value="1"> </el-option>
                <el-option label="已下架" value="0"> </el-option>
                <el-option label="已过期" value="-1"> </el-option>
              </el-select>
            </div>
            <div class="filter_item">
              <span class="filter_title">上架时间：</span>
              <el-date-picker
                v-model="topFilter.up_time"
                type="daterange"
                range-separator="至"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
                value-format="yyyy-MM-dd"
              >
              </el-date-picker>
            </div>
            <div class="filter_item">
              <span class="filter_title">下架时间：</span>
              <el-date-picker
                v-model="topFilter.down_time"
                type="daterange"
                range-separator="至"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
                value-format="yyyy-MM-dd"
              >
              </el-date-picker>
            </div>
          </show-more-filter>
          <div class="filter_action apaas_button">
            <el-button type="primary" @click="topFilterAction">
              查询
            </el-button>
            <el-button type="defalut" @click="topFilterClear">
              重置
            </el-button>
          </div>
        </div>
      </template>

      <el-button type="primary" @click="addNew" slot="header-left">
        新建
      </el-button>
    </apass-list>

    <apass-dialog
      ref="dialog"
      :msg="dialogInfo.msg"
      :submit="dialogInfo.submit"
    ></apass-dialog>
  </div>
</template>

<script>
import helper from "@/services/helper.js";
import apassList from "@/components/apass-list";
import apassDialog from "@/components/apass-dialog";
import showMoreFilter from "@/components/show-more-filter";

export default {
  components: {
    apassList,
    apassDialog,
    showMoreFilter,
  },
  data: () => ({
    listHeader: [],
    listData: [],
    listTotal: 0,
    dialogInfo: {
      msg: "",
      submit: null,
    },
    topFilter: {
      name: "",
      state: "",
      up_time: "",
      down_time: "",
    },
    tempFilter: null,
  }),
  created() {
    this.listHeader = [
      {
        label: "",
        prop: "state",
        type: "image-tooltip",
        getImage(item) {
          return [
            require("@/assets/imgs/ic_true.png"),
            require("@/assets/imgs/ic_failed.png"),
            require("@/assets/imgs/ic_guoqi.png"),
          ][item.state - 1];
        },
        getTooltip(item) {
          return ["已上架", "已下架", "已过期"][item.state - 1];
        },
        align: "center",
        width: 60,
      },
      {
        label: "排序",
        prop: "ordid",
        width: 60,
        align: "center",
      },
      {
        label: "banner编码",
        prop: "serial_num",
        width: 180,
      },
      {
        label: "banner名称",
        prop: "name",
        type: "button",
        callback: this.detailAction,
        width: 240,
      },
      {
        label: "链接地址",
        prop: "url",
      },
      {
        label: "图片大小",
        prop: "image_size",
        getText(item) {
          let value = item.image_size || 0;
          return (value / 1024).toFixed(2) + "KB";
        },
        width: 100,
      },
      {
        label: "上架时间",
        prop: "up_time",
        getText(item) {
          let date = item.up_time || "";
          return helper.dateStringTransform(date);
        },
        align: "center",
        width: 180,
      },
      {
        label: "下架时间",
        prop: "down_time",
        getText(item) {
          let date = item.down_time || "";
          return helper.dateStringTransform(date);
        },
        align: "center",
        width: 180,
      },
      {
        label: "操作",
        type: "buttons",
        align: "center",
        width: 320,
        actionList: [
          {
            label: "编辑",
            callback: this.editAction,
            disabledRule(item) {
              return item.state == 1;
            }
          },
          {
            label: "上架",
            callback: this.upAction,
            disabledRule(item) {
              return item.state == 1 || item.state == 3;
            }
          },
          {
            label: "下架",
            callback: this.downAction,
            disabledRule(item) {
              return item.state == 2 || item.state == 3;
            }
          },
          {
            label: "删除",
            class: "warn",
            callback: this.deleteAction,
            disabledRule(item) {
              return item.state == 1;
            }
          },
        ],
      },
    ];
  },
  methods: {
    initList(filter) {
      let fullFilter = {
        ...filter,
        ...this.topFilter,
      };

      this.tempFilter = filter; // filter存档，用于页面刷新

      console.log(fullFilter);

      this.$http
        .get("/apaas/service/v3/recommend/manage/banners/list", {
          params: {
            name: filter.keyword,
            page: filter.page,
            size: filter.size,
            state: filter.state,
            up_time_s:fullFilter.up_time?fullFilter.up_time[0]:'',
            up_time_e:fullFilter.up_time?fullFilter.up_time[1]:'',
            down_time_s:fullFilter.down_time?fullFilter.down_time[0]:'',
            down_time_e:fullFilter.down_time?fullFilter.down_time[1]:''
          },
        })
        .then(({ data }) => {
          if (data.success == 1) {
            this.listTotal = data.data.total;
            this.listData = data.data.data;
          } else {
            this.$message({
              message: data.errMsg || "获取列表失败",
              type: "warning",
            });
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    topFilterAction() {
      this.initList(this.tempFilter);
    },
    topFilterClear() {
      this.topFilter = {
        name: "",
        state: "",
        up_time: "",
        down_time: "",
      };

      this.initList(this.tempFilter);
    },
    showDialog() {
      this.$refs.dialog.show();
    },
    detailAction(item){
      this.$router.push('/message/banner_detail?id='+item.serial_num)
    },
    addNew() {
      console.log("新建模板");
      this.$router.push('/message/banner_add')
    },
    editAction(item) {
      console.log(item);
      this.$router.push('/message/banner_edit?id='+item.serial_num)
    },
    upAction(item) {
      this.$http
        .post("/apaas/service/v3/recommend/manage/banners/up",{
          serial_num:item.serial_num
        })
        .then(({ data }) => {
          if (data.success == 1) {
            this.$message.success('上架成功')
            this.initList(this.tempFilter)
          }
        })
    },
    downAction(item) {
      this.$http
        .post("/apaas/service/v3/recommend/manage/banners/down",{
          serial_num:item.serial_num
        })
        .then(({ data }) => {
          if (data.success == 1) {
            this.$message.success('下架成功')
            this.initList(this.tempFilter)
          }
        })
    },
    deleteAction(item) {
      // console.log(`删除${item.name}`);
      this.$http
        .post("/apaas/service/v3/recommend/manage/banners/del",[item.serial_num])
        .then(({ data }) => {
          if (data.success == 1) {
            this.$message.success('删除成功')
            this.initList(this.tempFilter)
          }else{
            this.$message.error('删除失败')
          }
        })
    },
  },
};
</script>

<style scoped>
.list_container {
  height: 100%;
}
</style>
